jQuery(function() {


    jQuery('.wrld-license-page-skip-now-button').on('click', function ( event ) {
        //ajax query to skip licensing;
        //action:
        event.preventDefault();
        let $this = jQuery(this);
        $this.text(wrld_admin_settings_data.wait_text);
        $this.css('cursor', 'progress');
        jQuery.ajax({
			url: wrld_admin_settings_data.wp_ajax_url,
			type: 'post',
			data: {
                'action': 'wrld_skip_license_activation',
                'nonce':wrld_admin_settings_data.nonce,
                'skip-licence':true
            },
			timeout: 60000, // sets timeout to 1 minute
			success: function(response){
                window.location.href=jQuery('.wrld-license-page-skip-now-button').data('link');
		  	},
		  	error: function(eventData){
			},
		});
    });

    jQuery('.wrld-license-action.action_activate').on('click', function( event ) {
        let license_key = jQuery('#wrld-pro-license-key').val();
        if (license_key.length<1) {
            alert('Please enter the valid license key');
            return;
        }

        event.preventDefault();
        let $this = jQuery(this);
        $this.text(wrld_admin_settings_data.wait_text);
        $this.css('cursor', 'progress');
        let edd_nonce = jQuery(this).closest('.wrld-dashboard-licence-tool-container').data('nonce');
        jQuery.ajax({
			url: wrld_admin_settings_data.wp_ajax_url,
			type: 'post',
			data: {
                'action': 'wrld_license_activate',
                'nonce':wrld_admin_settings_data.nonce,
                'license_key':license_key,
                'edd_learndash-reports-pro_nonce':edd_nonce,
            },
			timeout: 60000, // sets timeout to 1 minute
			success: function(response){
                window.location.href = jQuery('#wrld-license-activation').attr('href');
		  	},
		  	error: function(eventData){
                window.location.href = jQuery('#wrld-license-activation').attr('href');
			},
		});
    });

    jQuery('.wrld-license-action.action_deactivate').on('click', function(event) {
        event.preventDefault();
        let $this = jQuery(this);
        $this.text(wrld_admin_settings_data.wait_text);
        $this.css('cursor', 'progress');
        let edd_nonce = jQuery(this).closest('.wrld-dashboard-licence-tool-container').data('nonce');
        jQuery.ajax({
			url: wrld_admin_settings_data.wp_ajax_url,
			type: 'post',
			data: {
                'action': 'wrld_license_deactivate',
                'nonce':wrld_admin_settings_data.nonce,
                'edd_learndash-reports-pro_nonce':edd_nonce,
            },
			timeout: 60000, // sets timeout to 1 minute
			success: function(response){
                window.location.href = jQuery('#wrld-license-activation').attr('href');
		  	},
		  	error: function(eventData){
                window.location.href = jQuery('#wrld-license-activation').attr('href');
			},
		});
    });

    jQuery('.wrld-dashboard-button-action.set-config').on('click', function(event) {
        event.preventDefault();
        let $this = jQuery(this);
        $this.text(wrld_admin_settings_data.wait_text);
        $this.css('cursor', 'progress');
        let add_in_menu = jQuery('#wrld-menu-config-setting').is(':checked')?true:false;
        jQuery.ajax({
			url: wrld_admin_settings_data.wp_ajax_url,
			type: 'post',
			data: {
                'action': 'wrld_set_configuration',
                'nonce':wrld_admin_settings_data.nonce,
                'add_in_menu':add_in_menu,
            },
			timeout: 60000, // sets timeout to 1 minute
			success: function(response){
                window.location.href = jQuery('.wrld-dashboard-button-action.set-config').closest('a').attr('href');
		  	},
		  	error: function(eventData){
			},
		});
    });

   
    jQuery('#wrld-action-update-settings').on('click', function( event ){
        event.preventDefault();
        jQuery('.wrld-access-status.wrld-access-status-enabled, .wrld-access-status.wrld-access-status-disabled').css('display', 'none');
        let $this = jQuery(this);
        $this.text(wrld_admin_settings_data.wait_text);
        $this.css('cursor', 'progress');
        let add_in_menu = jQuery('#wrld-menu-config-setting').is(':checked')?true:false;
        let access_to_group_leader= jQuery('#wrld-menu-access-setting-group-leader').is(':checked')?true:false;
        let access_to_wdm_instructor= jQuery('#wrld-menu-access-setting-wdm-instructor').is(':checked')?true:false;
        jQuery.ajax({
			url: wrld_admin_settings_data.wp_ajax_url,
			type: 'post',
			data: {
                'action': 'wrld_update_settings',
                'nonce':wrld_admin_settings_data.nonce,
                'add_in_menu':add_in_menu,
                'access_to_group_leader':access_to_group_leader,
                'access_to_wdm_instructor':access_to_wdm_instructor
            },
			timeout: 60000, // sets timeout to 1 minute
			success: function(response){
                if(response.success){
                    jQuery('#wrld-action-update-settings').text('Apply');
                    if ( response.data.settings_data['dashboard-access-roles'].group_leader ){
                        jQuery('.wrld-access-status.wrld-group-leader-enabled').css('display', 'inline-block');
                    } else {
                        jQuery('.wrld-access-status.wrld-group-leader-disabled').css('display', 'inline-block');
                    }
                    let ir_active = ! jQuery('#wrld-menu-access-setting-wdm-instructor').is(':disabled');
                    if (ir_active) {
                        if ( response.data.settings_data['dashboard-access-roles'].wdm_instructor ){
                            jQuery('.wrld-access-status.wrld-wisdm-instructor-enabled').css('display', 'inline-block');
                        } else {
                            jQuery('.wrld-access-status.wrld-wisdm-instructor-disabled').css('display', 'inline-block');
                        }    
                    }
                    jQuery('#wrld-action-update-settings').css('cursor', 'not-allowed');
                    jQuery('#wrld-action-update-settings').attr('disabled', true);   
                }
		  	},
		  	error: function(eventData){

			},
		});
    });

    let params = new URLSearchParams(window.location.search);
    let page = params.get('page');
    jQuery.ajax({
        url: wrld_admin_settings_data.wp_ajax_url,
        type: 'post',
        data: {
            'action': 'wrld_license_page_visit',
            'nonce':wrld_admin_settings_data.nonce,
            'page':page
        },
        timeout: 60000, // sets timeout to 1 minute
        success: function(response){
            if(response.success){
                //do nothing
            }
          },
          error: function(eventData){
        },
    });


    jQuery('#wrld-menu-access-setting-group-leader, #wrld-menu-access-setting-wdm-instructor, #wrld-menu-config-setting').on('click', function (event) {
        jQuery('#wrld-action-update-settings').removeAttr('disabled');
        jQuery('#wrld-action-update-settings').css('cursor', 'pointer');
        if (this.checked) {
            jQuery(this).closest('label.checkbox-label').removeClass('no-access');
        } else {
            jQuery(this).closest('label.checkbox-label').addClass('no-access');
        }
    });

    jQuery('.wrld-license-page-config-button').on('click', function(){
        window.location.href=jQuery(this).data('link');
    });

});